rapidjson A fast JSON parser/generator for C++ with both SAX/DOM style API

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Functions Variables Typedefs Pages
Classes | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
rapidjson::MemoryPoolAllocator< BaseAllocator > Class Template Reference

Default memory allocator used by the parser and DOM. More...

`#include <rapidjson.h>`

Inheritance diagram for rapidjson::MemoryPoolAllocator< BaseAllocator >:

## Classes
struct | ChunkHeader
| Chunk header for perpending to each chunk.

## Public Member Functions
| MemoryPoolAllocator (size_t chunkSize=kDefaultChunkCapacity, BaseAllocator *baseAllocator=0)
| Constructor with chunkSize.
| MemoryPoolAllocator (char *buffer, size_t size, size_t chunkSize=kDefaultChunkCapacity, BaseAllocator *baseAllocator=0)
| Constructor with user-supplied buffer.
| ~MemoryPoolAllocator ()
| Destructor.
void | Clear ()
| Deallocates all memory chunks, excluding the user-supplied buffer.
size_t | Capacity ()
| Computes the total capacity of allocated memory chunks.
size_t | Size ()
| Computes the memory blocks allocated.
void * | Malloc (size_t size)
| Allocates a memory block. (concept Allocator)
void * | Realloc (void *originalPtr, size_t originalSize, size_t newSize)
| Resizes a memory block (concept Allocator)

## Static Public Member Functions
static void | Free (void *)
| Frees a memory block (concept Allocator)

## Static Public Attributes
static const bool | kNeedFree = false
| Tell users that no need to call Free() with this allocator. (concept Allocator)

## Detailed Description

### template<typename BaseAllocator = CrtAllocator>
class rapidjson::MemoryPoolAllocator< BaseAllocator >

Default memory allocator used by the parser and DOM.

This allocator allocate memory blocks from pre-allocated memory chunks.

It does not free memory blocks. And Realloc() only allocate new memory.

The memory chunks are allocated by BaseAllocator, which is CrtAllocator by default.

User may also supply a buffer as the first chunk.

If the user-buffer is full then additional chunks are allocated by BaseAllocator.

The user-buffer is not deallocated by this allocator.

Template Parameters

  BaseAllocator | the allocator type for allocating memory chunks. Default is CrtAllocator.

## Constructor & Destructor Documentation

template<typename BaseAllocator = CrtAllocator>

rapidjson::MemoryPoolAllocator< BaseAllocator >::MemoryPoolAllocator | ( | size_t | chunkSize = `kDefaultChunkCapacity`,
|  | BaseAllocator * | baseAllocator = `0`
| ) |  |
| inline

Constructor with chunkSize.

Parameters

  chunkSize | The size of memory chunk. The default is kDefaultChunkSize.
  baseAllocator | The allocator for allocating memory chunks.

template<typename BaseAllocator = CrtAllocator>

rapidjson::MemoryPoolAllocator< BaseAllocator >::MemoryPoolAllocator | ( | char * | buffer,
|  | size_t | size,
|  | size_t | chunkSize = `kDefaultChunkCapacity`,
|  | BaseAllocator * | baseAllocator = `0`
| ) |  |
| inline

Constructor with user-supplied buffer.

The user buffer will be used firstly. When it is full, memory pool allocates new chunk with chunk size.

        The user buffer will not be deallocated when this allocator is destructed.

        \param buffer User supplied buffer.
        \param size Size of the buffer in bytes. It must at least larger than sizeof(ChunkHeader).
        \param chunkSize The size of memory chunk. The default is kDefaultChunkSize.
        \param baseAllocator The allocator for allocating memory chunks.

template<typename BaseAllocator = CrtAllocator>

rapidjson::MemoryPoolAllocator< BaseAllocator >::~MemoryPoolAllocator | ( |  | ) |
| inline

Destructor.

This deallocates all memory chunks, excluding the user-supplied buffer.

## Member Function Documentation

template<typename BaseAllocator = CrtAllocator>

size_t rapidjson::MemoryPoolAllocator< BaseAllocator >::Capacity | ( |  | ) |
| inline

Computes the total capacity of allocated memory chunks.

Returns
  total capacity in bytes.

template<typename BaseAllocator = CrtAllocator>

size_t rapidjson::MemoryPoolAllocator< BaseAllocator >::Size | ( |  | ) |
| inline

Computes the memory blocks allocated.

Returns
  total used bytes.

The documentation for this class was generated from the following file:

- D:/rapidjson_version0.1x/include/rapidjson/rapidjson.h